/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.enums.EnumScreeningBaselineType;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidMacroException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;


/**
 * This class represents Information about the starting luminance screening values.
 */
public class ScreeningBaselineMeasuredSequenceItem extends Item
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	ScreeningBaselineMeasuredSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax.
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax 
	 */
	ScreeningBaselineMeasuredSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates ScreeningBaselineMeasuredSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	ScreeningBaselineMeasuredSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Validates all the attributes in ScreeningBaselineMeasuredSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try
		{
			if(!contains(0x0024,0x0124))
				throw new MandatoryMissingException("0024,0124");
			if(!contains(0x0024,0x0126))
				throw new MandatoryMissingException("0024,0126");
		}
		catch( ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),ce); 
		}
		catch( MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),me);
		}
		catch( InvalidMacroException ime)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ime.getMessage());
			}
			throw new InvalidItemException(this.getClass().getSimpleName(),ime);
		}
		return true;
	}
	/**
	 * Sets the method used to determine starting luminance screening values.
	 *Enumerated Values:
	 *CENTRAL
	 *PERIPHERAL
	 * @param enumScreeningBaselineType enum value of Screening Baseline Type.
	 */
	public void setScreeningBaselineType(EnumScreeningBaselineType enumScreeningBaselineType)
	{
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0024,0x0124, enumScreeningBaselineType.getValue(),getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0024,0x0124,DicomConstants.DCM_DT_CS, enumScreeningBaselineType.getValue());

		addDataElement(objIDataElement);
	}
	/**
	 * Return type of Screening Baseline Type. 
	 * @return String - value of Screening Baseline Type.
	 */
	public String getScreeningBaselineType()
	{
		Object objValue = getValue(0x0024,0x0124);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	/**
	 * Sets the Visual Field screening baseline value, in dB.
	 * @param fScreeningBaselineValue Float value of Visual Field screening baseline value, in dB.
	 */
	public void setScreeningBaselineValue( float fScreeningBaselineValue)
	{
		/*
		 * Accept the Screening Baseline Value in String format of type FL.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x0024,0x0126, fScreeningBaselineValue,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0024,0x0126,DicomConstants.DCM_DT_FL, fScreeningBaselineValue);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Visual Field screening baseline value, in dB.
	 * @return float - Float value of Visual Field screening baseline value, in dB.
	 */
	public float getScreeningBaselineValue()
	{
		Object objValue = getValue(0x0024,0x0126);
		if(objValue != null)
			return Float.parseFloat(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
}
